{ NOTAS: }
{ Para ampliar los botones hay que establecer el nuevo botn en
  RESULTADOS,
  TIPO DE MENSAJE,
  TEXTO DE MENSAJE
  y aadir la imagen que se desea a mensajes.dcr con el nombre que se ponga en
  GLYPS como nombre del resource
  Para ampliar los tipos de mensajes, se ha de establecer el tipo en
  TMENSAJETIPO,}

unit Mensajes;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Buttons, StdCtrls, ExtCtrls, CEdit;

type

  Resultados = (mrNinguno, mrAceptar, mrCancelar, mrBuscar, mrCrear, mrSi, mrNo, mrReintentar, mrAbortar,mrIgnorar, mrCerrar, mrAyuda, mrImprimir);
  TipodeMensaje = (bkNinguno, bkAceptar, bkCancelar, bkBuscar, bkCrear, bkSi, bkNo, bkReintentar, bkAbortar, bkIgnorar, bkCerrar, bkAyuda, bkImprimir);
  ResultadoModal = array[TipodeMensaje] of Resultados;
  GrupodeBotones = set of TipodeMensaje;
  TMensajeTipo = (mtInformacion, mtConfirmacion, mtCuidado, mtError);

  TMensajes = class(TComponent)
  private
         function GetGrupodeBotones: GrupodeBotones;
         procedure SetGrupodeBotones(Value: GrupodeBotones);
         function GetDetail: Boolean;
         procedure SetDetail(Value: Boolean);
         function GetMensajeTipo: TMensajeTipo;
         procedure SetMensajeTipo(Value: TMensajeTipo);
         function GetMensajeError: String;
         procedure SetMensajeError(Value: String);
         function GetCaption: String;
         procedure SetCaption(Value: String);
         function GetFBeep: Boolean;
         procedure SetFBeep(Value: Boolean);
         function GetFTitulosdeEditores: TStrings;
         procedure SetFTitulosdeEditores(Value: TStrings);
    { Private declarations }
  public
        constructor Create(Aowner: TComponent);override;
        destructor Destroy;
    { Public declarations }
  published
           property Buttons: GrupodeBotones read GetGrupodeBotones write SetGrupodeBotones;
           property DetailButton: Boolean read GetDetail write SetDetail default True;
           property MensajeTipo: TMensajeTipo read GetMensajeTipo write SetMensajeTipo;
           property MensajeError: String read GetMensajeError write SetMensajeError;
           property WindowCaption:String read GetCaption write SetCaption;
           property SoundEfect: Boolean read GetFBeep write SetFBeep default True;
           property InputEditsTitles: TStrings read GetFTitulosdeEditores write SetFTitulosdeEditores;
  end;

  TInputMensajes = class(TComponent)
  private
  public
  end;


  TObjeto = class (TObject) { Es slo para asignar una procedure al onclick de los botones }
  private
         procedure DetalleClick(Sender: TObject);
         procedure CrearClick(Sender: TObject);
         procedure CloseModal;
  end;

const
  TextoBotones: array[TipodeMensaje] of String = ('Ninguno', '&Aceptar', 'Cancelar', '&Buscar', '&Crear', '&Si', '&No', '&Reintentar', 'Ab&ortar', 'I&gnorar', 'C&errar', 'A&yuda', '&Imprimir');
  Imagenes: array[TMensajeTipo] of String = ('Informacion', 'Confirmacion', 'Cuidado', 'Error');
  Cabeceras: array[TMensajeTipo] of String = ('Informacin', 'Confirmacin', 'Cuidado', 'Error');
  Glyps: array[0..Ord(High(TipodeMensaje))] of String = ('','ACEPTAR','CANCELAR','BUSCAR','INSERTAR','SI','NO','REINTENTAR','ABORTAR','IGNORAR','CERRAR','AYUDA','IMPIMIR');
  NumEditores = 12;

var
  FGrupodeBotones: GrupodeBotones;
  FocusCount: Integer = 0;
  VentanadeMensajes: TForm;
  MemoMensaje: String;
  FResultado: Resultados;
  FFormState: TFormState;
  Retorno: array[0..Ord(High(TipodeMensaje))] of Resultados;
  Boton: array [0..Ord(High(TipodeMensaje))] of TBitBtn;
  BtnDetalle: TBitBtn;
  MemoError: TMemo;
  Image1: TImage;
  ImageList1: TImageList;
  Objeto: TObjeto;
  FDetail: Boolean;
  FMensajeTipo: TMensajeTipo;
  FMensajeError: String;
  Fcaption: String;
  FBeep: Boolean;
  Editor: array[0..NumEditores] of TColorEdit;
  Titulo: array[0..NumEditores] of TLabel;
  FTitulosdeEditores: TStrings;


procedure CreaBotones(SetdeBotones: GrupodeBotones; ConDetalle: Boolean; PosicionBotones: Integer);
procedure CreaVentana(Posicion: TPosition; X,Y: Integer);
procedure CreaImagen;
procedure MuestraVentana;
function DlgMensajes(Mensaje: String): Resultados;
function InputMensajes(var ControlesdeEdicion: array of String; Mensaje: String): Resultados;
procedure ShowMensajes(Mensaje: STring);
procedure Register;

implementation

{$R GLYPS.DCR}
procedure Register;
begin
     RegisterComponents ('Dialogs', [TMensajes]);
end;

constructor TMensajes.Create(Aowner: TComponent);
begin
     inherited Create(Aowner);
     FMensajeTipo := mtInformacion;
     FCaption := 'Informacion';
     FTitulosdeEditores := TStringList.Create;
     FDetail := True;
     FBeep := True;
end;

destructor TMensajes.Destroy;
begin
     inherited Destroy;
     FTitulosdeEditores.Free;
end;

function DlgMensajes(Mensaje: String): Resultados;
var
   WindowList: Pointer;
   SaveFocusCount: Integer;
   SaveFocusedForm: TForm;
   SaveCursor: TCursor;
   ActiveWindow: HWnd;
   Texto: TLabel;
   n, m, p: Integer;
begin
     CreaVentana(poScreenCenter, 0,0);
{ Creacion de Controles }
     Texto := TLabel.Create(VentanadeMensajes);
{ Diseo del Mensaje }
     with Texto do
     begin
          Visible := False;
          ParentFont := False;
          Font.Style := [];
          Parent := VentanadeMensajes;
          WordWrap := True;
          Left := Image1.Left + Image1.Width + 10;
          Top := 18;
          Width := VentanadeMensajes.Width - Image1.Width  - 10;
          Autosize := True;
          Caption := Mensaje;
          Visible := True;
     end;
     VentanadeMensajes.Height := Texto.Height + 105;
     CreaBotones(FGrupodeBotones, FDetail, VentanadeMensajes.Height - 35);
     MuestraVentana;
     Texto.Visible := False;
     Texto.Free;
end;

function InputMensajes(var ControlesdeEdicion: array of String; Mensaje: String): Resultados;
var
   WindowList: Pointer;
   SaveFocusCount: Integer;
   SaveFocusedForm: TForm;
   SaveCursor: TCursor;
   ActiveWindow: HWnd;
   Texto: TLabel;
   n, m, p: Integer;
   NEditores: Integer;
begin
     if High(ControlesdeEdicion) > NumEditores then
        NEditores := NumEditores
     else
         NEditores := High(ControlesdeEdicion);
     CreaVentana(poScreenCenter, 0, 0);
{ Creacion de Controles }
     Texto := TLabel.Create(VentanadeMensajes);
{ Diseo del Mensaje }
     with Texto do
     begin
          Visible := False;
          ParentFont := False;
          Font.Style := [];
          Parent := VentanadeMensajes;
          WordWrap := True;
          Left := Image1.Left + Image1.Width + 10;
          Top := 18;
          Width := VentanadeMensajes.Width - Image1.Width  - 10;
          Autosize := True;
          Caption := Mensaje;
          Visible := True;
     end;
     for n := 0 to NEditores do
     begin
          Titulo[n] := TLabel.Create(VentanadeMensajes);
          Editor[n] := TColorEdit.Create(VentanadeMensajes);
          with Editor[n] do
          begin
               Visible := False;
               Parent := VentanadeMensajes;
               EnterColor := clAqua;
               ParentFont := False;
               Font.Style := [];
               Width := VentanadeMensajes.Width - 30;
               Left := (VentanadeMensajes.Width - Editor[n].Width) div 2;
               Top := Texto.Top + Texto.Height + (n * Editor[n].Height + (Titulo[n].Height)* (n+1)) + 25;
               Visible := True;
          end;
          with Titulo[n] do
          begin
               Visible := False;
               Parent := VentanadeMensajes;
               AutoSize := True;
               if n < FTitulosdeEditores.Count then
                  Caption := FTitulosdeEditores[n];
               Left := (VentanadeMensajes.Width - Editor[n].Width) div 2;
               Top := Editor[n].Top - Titulo[n].Height - 2;
               Visible := True;
          end;
     end;

     CreaBotones([bkAceptar, bkCancelar], False, Editor[n-1].Top + Editor[n-1].Height + 40);
     MuestraVentana;
     for n:= 0 to NEditores do
         ControlesdeEdicion[n] := Editor[n].Text;
     for n := 0 to NEditores - 1  do
     begin
          Editor[n].Visible := False;
          Editor[n].Free;
          Titulo[n].Visible := False;
          Titulo[n].Free;
     end;
     Texto.Visible := False;
     Texto.Free;
end;
procedure TObjeto.CrearClick(Sender: TObject);
var
   n: Integer;
begin
     for n := 0 to Ord(High(TipodeMensaje)) do
         if Sender = Boton[n] then
         begin
              FResultado := Retorno[n];
              Break;
         end;
end;

procedure TObjeto.CloseModal;
var
  CloseAction: TCloseAction;
begin
  try
    CloseAction := caNone;
    if VentanadeMensajes.CloseQuery then
    begin
      CloseAction := caHide;
    end;
    case CloseAction of
      caNone: FResultado := mrCancelar;
      caFree: VentanadeMensajes.Release;
    end;
  except
    FResultado := mrCancelar;
    Application.HandleException(Self);
  end;
end;

procedure TObjeto.DetalleClick(Sender: TObject);
begin
     if BtnDetalle.Caption = 'Detalle >>' then
     begin
          MemoError := TMemo.Create(VentanadeMensajes);
          with MemoError do
          begin
               Visible := False;
               Color := clBtnFace;
               Parent := VentanadeMensajes;
               ParentFont := False;
               Font.Style := [];
               Left := 5;
               Width := VentanadeMensajes.Width - 15;
               Height := 120;
               Top := VentanadeMensajes.Height - 30;
               Text := MemoMensaje;
               Visible := True;
          end;
          BtnDetalle.Caption := '<< No detalle';
          VentanadeMensajes.Height := VentanadeMensajes.Height + 120;
     end
     else
     begin
          VentanadeMensajes.Height := VentanadeMensajes.Height - 120;
          BtnDetalle.Caption := 'Detalle >>';
          MemoError.free;
     end;
end;

function TMensajes.GetGrupodeBotones: GrupodeBotones;
begin
     Result := FGrupodeBotones;
end;

procedure TMensajes.SetDetail(Value: Boolean);
begin
     FDetail := Value;
end;

function TMensajes.GetDetail: Boolean;
begin
     Result := FDetail;
end;

procedure TMensajes.SetGrupodeBotones(Value: GrupodeBotones);
begin
     FGrupodeBotones := Value;
end;

function TMensajes.GetMensajeTipo: TMensajeTipo;
begin
     Result := FMensajeTipo;
end;

procedure TMensajes.SetMensajeTipo(Value: TMensajeTipo);
begin
     FMensajeTipo := Value;
     FCaption := Cabeceras[TMensajeTipo(Value)];
     SetCaption(Cabeceras[TMensajeTipo(Value)]);
end;

function TMensajes.GetMensajeError: String;
begin
     Result := FMensajeError;
end;

procedure TMensajes.SetMensajeError(Value: String);
begin
     FMensajeError := Value;
end;

function TMensajes.GetCaption: String;
begin
     Result := FCaption;
end;

procedure TMensajes.SetCaption(Value: String);
begin
     FCaption := Value;
end;

function TMensajes.GetFBeep: Boolean;
begin
     Result := FBeep;
end;

procedure TMensajes.SetFBeep(Value: Boolean);
begin
     FBeep := Value;
end;

procedure CreaBotones(SetdeBotones: GrupodeBotones; ConDetalle: Boolean; PosicionBotones: Integer);
var
   n, p, m: Integer;
begin
     p := 0;
     for n := 0 to Ord(High(TipodeMensaje)) do
          if TipodeMensaje(n) in SetdeBotones then
             Inc(p);
     if VentanadeMensajes.Width < (p + 2) * 80 then
        VentanadeMensajes.Width := (p + 2) * 82;
     VentanadeMensajes.Height := PosicionBotones + 35;
     if ConDetalle then
     begin
          BtnDetalle := TBitBtn.Create(VentanadeMensajes);
          with BtnDetalle do
          begin
               Visible := False;
               Parent := VentanadeMensajes;
               Caption := 'Detalle >>';
               Left := VentanadeMensajes.Width - Width - 10;
               Top := PosicionBotones - Height;
               Font.Style := [];
               ParentFont := False;
               OnClick := Objeto.DetalleClick;
               Visible := True;
          end;
     end;
     m := 0;
     for n := 0 to Ord(High(TipodeMensaje)) do
     begin
          if TipodeMensaje(n) in SetdeBotones then
          begin
               Boton[m] := TBitBtn.Create(VentanadeMensajes);
               Boton[m].Width := 80;
               with Boton[m] do
               begin
                    Visible := False;
                    Parent := VentanadeMensajes;
                    ParentFont := False;
                    Font.Style := [];
                    if ConDetalle then
                       Left := (VentanadeMensajes.Width - p * 80) div 3 + ((Boton[m].Width) * m )
                    else
                        Left := (VentanadeMensajes.Width - p * 80) div 2 + ((Boton[m].Width) * m);
                    Top := PosicionBotones - Height;
                    Caption := TextoBotones[TipodeMensaje(n)];
                    Glyph.LoadFromResourceName(0,Glyps[n]);
                    OnClick := Objeto.CrearClick;
                    Margin := -1;
                    Spacing := 4;
                    Retorno[m] := Resultados(n);
                    Visible := True;
                    Inc(m);
               end;
          end;
     end;
end;

function TMensajes.GetFTitulosdeEditores: TStrings;
begin
     Result := FTitulosdeEditores;
end;

procedure TMensajes.SetFTitulosdeEditores(Value: TStrings);
begin
     FTitulosdeEditores.Assign(Value);
end;

procedure ShowMensajes(Mensaje: String);
var
   WindowList: Pointer;
   SaveFocusCount: Integer;
   SaveFocusedForm: TForm;
   SaveCursor: TCursor;
   ActiveWindow: HWnd;
   Texto: TLabel;
   n, m, p: Integer;
begin
     CreaVentana(poScreenCenter, 0,0);
{ Creacion de Controles }
     Texto := TLabel.Create(VentanadeMensajes);
{ Diseo del Mensaje }
     with Texto do
     begin
          Visible := False;
          ParentFont := False;
          Font.Style := [];
          Parent := VentanadeMensajes;
          WordWrap := True;
          Left := Image1.Left + Image1.Width + 10;
          Top := 18;
          Width := VentanadeMensajes.Width - Image1.Width  - 10;
          Autosize := True;
          Caption := Mensaje;
          Visible := True;
     end;
     VentanadeMensajes.Height := Texto.Height + 105;
     CreaBotones([bkAceptar], False, VentanadeMensajes.Height - 35);
     MuestraVentana;
     Texto.Visible := False;
     Texto.Free;
end;

procedure ShowMensajesPos(Mensaje: String; X, Y: Integer);
var
   Texto: TLabel;
   n, m, p: Integer;
begin
     CreaVentana(poScreenCenter, X, Y);
{ Creacion de Controles }
     Texto := TLabel.Create(VentanadeMensajes);
{ Diseo del Mensaje }
     with Texto do
     begin
          Visible := False;
          ParentFont := False;
          Font.Style := [];
          Parent := VentanadeMensajes;
          WordWrap := True;
          Left := Image1.Left + Image1.Width + 10;
          Top := 18;
          Width := VentanadeMensajes.Width - Image1.Width  - 10;
          Autosize := True;
          Caption := Mensaje;
          Visible := True;
     end;
     VentanadeMensajes.Height := Texto.Height + 105;
     CreaBotones([bkAceptar], False, VentanadeMensajes.Height - 35);
     MuestraVentana;
     Texto.Visible := False;
     Texto.Free;

end;

procedure CreaVentana(Posicion: TPosition; X,Y: Integer);
var
   n: Integer;
begin
     if FBeep then
        Beep;
     VentanadeMensajes := TForm.Create(Application);
     MemoMensaje := FMensajeError;
     with VentanadeMensajes do
     begin
          for n := 0 to Ord(High(TipodeMensaje)) do
              Retorno[n]:= mrNinguno;
          Font.Style := [fsBold];
          Caption := 'Informacin';
          BorderStyle := bsDialog;
          CreaImagen;
          Caption := FCaption;
          if Posicion <> poScreenCenter then
          begin
               Position := poDesigned;
               Left := X;
               Top := Y;
          end
          else
              Position := poScreenCenter;
     end;
end;

procedure CreaImagen;
begin
     Image1:= TImage.Create(nil);
     with Image1 do
     begin
          Visible := False;
          Parent := VentanadeMensajes;
          Left := 40;
          Top := 15;
          Width := 37;
          Height := 37;
          Picture.Bitmap.LoadFromResourceName(0, IMAGENES[TMensajeTipo(FMensajeTipo)]);
          Visible := True;
     end;
end;

procedure MuestraVentana;
var
   WindowList: Pointer;
   SaveFocusCount: Integer;
   SaveFocusedForm: TForm;
   SaveCursor: TCursor;
   ActiveWindow: HWnd;
begin
     ActiveWindow := GetActiveWindow;
     SaveFocusCount := FocusCount;
     SaveCursor := Screen.Cursor;
     Screen.Cursor := crDefault;
     WindowList := DisableTaskWindows(0);
     try
        VentanadeMensajes.Show;
        try
           SendMessage(VentanadeMensajes.Handle, CM_ACTIVATE, 0, 0);
           FResultado := mrNinguno;
           repeat
                 Application.HandleMessage;
                 if not VentanadeMensajes.Active then FResultado := mrCancelar;
                 if Application.Terminated then FResultado := mrCancelar else
                 if FResultado <> mrNinguno then Objeto.CloseModal;
           until FResultado <> mrNinguno;
           SendMessage(VentanadeMensajes.Handle, CM_DEACTIVATE, 0, 0);
           if GetActiveWindow <> VentanadeMensajes.Handle then ActiveWindow := 0;
           finally
                  VentanadeMensajes.Hide;
           end;
        finally
               Screen.Cursor := SaveCursor;
               EnableTaskWindows(WindowList);
               if ActiveWindow <> 0 then SetActiveWindow(ActiveWindow);
                  FocusCount := SaveFocusCount;
               Exclude(FFormState, fsModal);
        end;
end;

end.
